<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns="http://www.w3.org/1999/xhtml">

    <h:form id="uuidForm">
        <gri:popupPanel id="uuid_modalpanel_editor">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.EditUuid']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#uuid_modalpanel_editor').modal('hide')"
                                   execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   onclick="jq162('#uuid_modalpanel_editor').modal('hide');"
                                   render="uuid_content"/>
            </f:facet>
            <s:decorate id="uuid_view">
                <a4j:region>
                    <s:decorate id="formuuid" template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Uuid']}</ui:define>
                        <h:inputText value="#{selectedRO.uuid}" styleClass="form-control"/>
                    </s:decorate>
                </a4j:region>
            </s:decorate>
        </gri:popupPanel>
    </h:form>

    <h:form id="nmp_form">
        <gri:popupPanel id="name_modalpanel_editor">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.EditName']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#name_modalpanel_editor').modal('hide')"
                                   execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   onclick="jq162('#name_modalpanel_editor').modal('hide');"
                                   render="name_content"/>
            </f:facet>
            <a4j:region>
                <s:decorate id="name_view">
                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Name_2']}</ui:define>
                        <h:inputText value="#{selectedRO.name}" styleClass="form-control"/>
                    </s:decorate>
                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>

    <h:form id="dise_form">
        <gri:popupPanel id="displayAttributeName_modalpanel_editor">
            <f:facet name="header">
                <h:outputText
                        value="#{messages['net.ihe.gazelle.xdstar.EditDisplayAttributeName']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#displayAttributeName_modalpanel_editor').modal('hide')"
                                   execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   onclick="jq162('#displayAttributeName_modalpanel_editor').modal('hide');"
                                   render="displayAttributeName_content"/>
            </f:facet>
            <a4j:region>
                <s:decorate id="displayAttributeName_view">
                    <s:decorate id="formdisplayAttributeName"
                                template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.DisplayAttributeName']}</ui:define>
                        <h:inputText value="#{selectedRO.displayAttributeName}" styleClass="form-control"/>
                    </s:decorate>
                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>

    <h:form id="vp_form">
        <gri:popupPanel id="value_modalpanel_editor">
            <f:facet name="header">
                <h:outputText
                        value="#{messages['net.ihe.gazelle.xdstar.EditValue']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#value_modalpanel_editor').modal('hide')"
                                   execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   onclick="jq162('#value_modalpanel_editor').modal('hide');"
                                   render="value_content"/>
            </f:facet>
            <a4j:region>
                <s:decorate id="formvalue">
                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Value']}</ui:define>
                        <h:inputText value="#{selectedRO.value}" styleClass="form-control"/>
                    </s:decorate>
                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>

    <h:form id="cadd_form">
        <gri:popupPanel id="classification_add" bodyStyleClass="gzl-select-modal-overflow-visible">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.AddClassification']}"/>
            </f:facet>
            <f:facet name="footer">
                <div align="left">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                       onclick="jq162('#classification_add').modal('hide')"
                                       execute="@this"/>
                    <a4j:commandButton styleClass="gzl-btn-green"
                                       value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                       actionListener="#{selectedRO.addClassification(ROManager.selectedClassification,ROManager.selectedCardinalityEnum)}"
                                       onclick="jq162('#classification_add').modal('hide');"
                                       render="classification_content"/>
                </div>
            </f:facet>
            <a4j:region>
                <s:decorate id="classification_add_dec">

                    #{ROManager.setSelectedClassification(null)}
                    #{ROManager.setSelectedCardinalityEnum(null)}

                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.ClassificationMetadata']}</ui:define>
                        <h:selectOneMenu id="selectCar" styleClass="form-control gzl-form-control gzl-select-text"
                                         value="#{ROManager.selectedClassification}">
                            <s:selectItems
                                    value="#{metadataEditorManager.getAvailableClassifications()}"
                                    var="cl"
                                    noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                    label="#{cl.displayAttributeName}"/>
                        </h:selectOneMenu>
                    </s:decorate>

                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Cardinality']}</ui:define>
                        <h:selectOneMenu id="selectCarinality" styleClass="form-control gzl-form-control gzl-select-text"
                                         value="#{ROManager.selectedCardinalityEnum}">
                            <s:selectItems
                                    value="#{metadataEditorManager.getAvailableCardinalityString()}"
                                    var="cl"
                                    noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                    label="#{cl}"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>

    <h:form id="slad_form">
        <gri:popupPanel id="slot_add" bodyStyleClass="gzl-select-modal-overflow-visible">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.AddSlot']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#slot_add').modal('hide')" execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   actionListener="#{selectedRO.addSlot(ROManager.selectedSlot,ROManager.selectedCardinalityEnum)}"
                                   onclick="jq162('#slot_add').modal('hide');"
                                   render="globalpanel"/>
            </f:facet>
            <a4j:region>
                #{ROManager.setSelectedCardinalityEnum(null)}
                <s:decorate id="slot_add_dec">
                    <ui:include src="slotAttr.xhtml">
                        <ui:param name="slot" value="#{ROManager.selectedSlot}"/>
                    </ui:include>
                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>

    <h:form id="eie_form">
        <gri:popupPanel id="external_identifier_edit" bodyStyleClass="gzl-select-modal-overflow-visible">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.EditExternalIdentifier']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#external_identifier_edit').modal('hide')"
                                   execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   onclick="jq162('#external_identifier_edit').modal('hide');"
                                   render="ext_identifier_content"/>
            </f:facet>
            <a4j:region>
                <s:decorate id="external_identifier_edit_dec">
                    <s:decorate template="/layout/form/_edit.xhtml" rendered="#{ROManager.selectedExternalIdentifierMetadataDescriber != null}">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.ExternalIdentifierMetadata_3']}
                        </ui:define>
                        <h:selectOneMenu id="selectCar" styleClass="form-control gzl-form-control gzl-select-text"
                                         value="#{ROManager.selectedExternalIdentifierMetadataDescriber.eim}">
                            <s:selectItems
                                    value="#{metadataEditorManager.getAvailableExts()}"
                                    var="cl"
                                    noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                    label="#{cl.displayAttributeName}"/>
                        </h:selectOneMenu>
                    </s:decorate>

                    <s:decorate template="/layout/form/_edit.xhtml" rendered="#{ROManager.selectedExternalIdentifierMetadataDescriber != null}">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Cardinality']}</ui:define>
                        <h:selectOneMenu id="selectCarinality" styleClass="form-control gzl-form-control gzl-select-text"
                                         value="#{ROManager.selectedExternalIdentifierMetadataDescriber.cardinality}">
                            <s:selectItems
                                    value="#{metadataEditorManager.getAvailableCardinalityEnum()}"
                                    var="cl"
                                    noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                    label="#{cl}"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>
    <h:form id="se_form">
        <gri:popupPanel id="slot_edit" bodyStyleClass="gzl-select-modal-overflow-visible">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.EditSlot']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton id="canceleditslot" styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#slot_edit').modal('hide')" execute="@this"/>
                <a4j:commandButton id="saveeditslot" styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   actionListener="#{ROManager.saveSelectedSlot(ROManager.selectedSlotDescriber.slotMetadata, ROManager.selectedCardinalityEnum)}"
                                   onclick="jq162('#slot_edit').modal('hide');"
                                   render="globalpanel"/>
            </f:facet>
            <a4j:region>
                <s:decorate id="slot_edit_form" ajaxSubmit="true">
                    <ui:include src="slotAttr.xhtml">
                        <ui:param name="slot" value="#{ROManager.selectedSlotDescriber.slotMetadata}"/>
                    </ui:include>
                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>

    <h:form id="extadd_form">
        <gri:popupPanel id="ext_add" bodyStyleClass="gzl-select-modal-overflow-visible">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.AddExternalIdentifier']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#ext_add').modal('hide')" execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   actionListener="#{selectedRO.addExt_identifier(ROManager.selectedExt,ROManager.selectedCardinalityEnum)}"
                                   onclick="jq162('#ext_add').modal('hide');"
                                   render="ext_identifier_content"/>
            </f:facet>
            <a4j:region>
                <s:decorate id="ext_add_dec">

                    #{ROManager.setSelectedExt(null)}
                    #{ROManager.setSelectedCardinalityEnum(null)}

                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.ExternalIdentifier']}</ui:define>
                        <h:selectOneMenu id="selectCar" value="#{ROManager.selectedExt}" styleClass="form-control gzl-form-control gzl-select-text">
                            <s:selectItems
                                    value="#{metadataEditorManager.getAvailableExts()}" var="cl"
                                    noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                    label="#{cl.displayAttributeName}"/>
                        </h:selectOneMenu>
                    </s:decorate>

                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Cardinality']}</ui:define>
                        <h:selectOneMenu id="selectCardinality" styleClass="form-control gzl-form-control gzl-select-text"
                                         value="#{ROManager.selectedCardinalityEnum}">
                            <s:selectItems
                                    value="#{metadataEditorManager.getAvailableCardinalityString()}"
                                    var="cl"
                                    noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                    label="#{cl}"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>

    <h:form id="add_form">
        <gri:popupPanel id="usages_add" bodyStyleClass="gzl-select-modal-overflow-visible">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.AddUsage']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#usages_add').modal('hide')" execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   actionListener="#{selectedRO.usages.add(ROManager.selectedUsage)}"
                                   onclick="jq162('#usages_add').modal('hide');"
                                   render="usages_content"/>
            </f:facet>
            <a4j:region>
                <s:decorate id="usages_add_dec">

                    #{ROManager.setSelectedUsage(null)}

                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Usage']}</ui:define>
                        <h:selectOneMenu id="selectCar" value="#{ROManager.selectedUsage}" styleClass="form-control gzl-form-control gzl-select-text">
                            <s:selectItems
                                    value="#{metadataEditorManager.getAvailableUsages()}" var="cl"
                                    noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                    label="#{cl.affinity.keyword} =&gt; #{cl.transaction.keyword}"/>
                        </h:selectOneMenu>
                    </s:decorate>


                </s:decorate>
            </a4j:region>
        </gri:popupPanel>
    </h:form>

    <h:form id="ce_form">
        <gri:popupPanel id="classification_edit" bodyStyleClass="gzl-select-modal-overflow-visible">
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.EditClassification']}"/>
            </f:facet>
            <f:facet name="footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                   onclick="jq162('#classification_edit').modal('hide')"
                                   execute="@this"/>
                <a4j:commandButton styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                   actionListener="#{ROManager.selectedClassificationDescriber.updateContent(ROManager.selectedClassification,ROManager.selectedCardinalityEnum)}"
                                   onclick="jq162('#classification_edit').modal('hide');"
                                   render="classification_content"/>
            </f:facet>
            <s:div id="classification_edit_dec">
                <s:decorate rendered="#{ROManager.selectedClassificationDescriber != null}">
                    <h:outputText value="#{messages['net.ihe.gazelle.xdstar.ClassificationMetadata']}"/>
                    <br/>
                    <h:selectOneMenu id="selectCar" styleClass="form-control gzl-form-control gzl-select-text"
                                     value="#{ROManager.selectedClassification}">
                        <s:selectItems
                                value="#{metadataEditorManager.getAvailableClassifications()}"
                                var="cl"
                                noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                label="#{cl.displayAttributeName}"/>
                    </h:selectOneMenu>
                    <br/>
                    <h:outputText value="#{messages['net.ihe.gazelle.xdstar.Cardinality']}"/>
                    <h:selectOneMenu id="selectCarinality" styleClass="form-control gzl-form-control gzl-select-text"
                                     value="#{ROManager.selectedCardinalityEnum}">
                        <s:selectItems
                                value="#{metadataEditorManager.getAvailableCardinalityString()}"
                                var="cl"
                                noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                label="#{cl}"/>
                    </h:selectOneMenu>
                    <br/>

                </s:decorate>
            </s:div>
        </gri:popupPanel>
    </h:form>
</ui:composition>